--- dbf2mysql-1.14a/mysql2dbf.c	2007-08-03 12:19:22.000000000 +0200
+++ dbf/mysql2dbf.c	2007-08-03 12:22:28.000000000 +0200
@@ -201,12 +201,12 @@
 	  
 	  strtoupper(qfield->name);
 	  switch (qfield->type) {
-	    /* assume INT's have a max. of 10 digits (4^32 has 10 digits) */
+
 	  case FIELD_TYPE_CHAR:
 	  case FIELD_TYPE_SHORT:
 	  case FIELD_TYPE_LONG:
 	  
-	    dbf_add_field(dbh, qfield->name, 'N', 10, 0);
+	    dbf_add_field(dbh, qfield->name, 'N', qfield->length, 0);
 	    if (verbose > 1) {
 	      printf("Adding field: %s, INT_TYPE, %d\n", qfield->name,
 		     qfield->length);
@@ -217,6 +217,7 @@
 	  case FIELD_TYPE_DOUBLE:
 	  case FIELD_TYPE_FLOAT:
 	  case FIELD_TYPE_DECIMAL:
+	  case FIELD_TYPE_NEWDECIMAL:
 	    dbf_add_field(dbh, qfield->name, 'N', qfield->length,
 			  qfield->decimals);
 	    if (verbose > 1) {
@@ -230,10 +231,18 @@
 	  case FIELD_TYPE_TINY_BLOB:
 	  case FIELD_TYPE_MEDIUM_BLOB:
 	  case FIELD_TYPE_LONG_BLOB:
-	    dbf_add_field(dbh, qfield->name, 'C', qfield->length, 0);
-	    if (verbose > 1) {
-	      printf("Adding field: %s, INT_CHAR, %d\n", qfield->name,
-		     qfield->length);
+	    if (qfield->flags & ENUM_FLAG) {
+	      dbf_add_field(dbh, qfield->name, 'L', 1, 2);
+  	      if (verbose > 1) {
+	        printf("Adding field: %s, INT_ENUM, %d\n", qfield->name,
+		       qfield->length);
+	      }
+	    } else {
+	      dbf_add_field(dbh, qfield->name, 'C', qfield->length, 0);
+	      if (verbose > 1) {
+	        printf("Adding field: %s, INT_CHAR, %d\n", qfield->name,
+		       qfield->length);
+	      }
 	    }
 	    break;
 	  case FIELD_TYPE_DATETIME:
@@ -254,6 +263,8 @@
 	    }
 	    break;
 	  default:
+	    if (verbose > 1)
+	      printf("Unknown field type: %d\n", qfield->type);
 	    break;
 	  }
 	}
